/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ESPECBEMATIVO                                            */
/* Tabela : ESPECBEMATIVO                                                     */
/*                                                                            */
/* Criao:                                                                   */
/* 26/03/2009 - Luciana Correa de Figueiredo                                  */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE
TRIGGER DTULTATU_ESPECBEMATIVO
BEFORE INSERT OR UPDATE OR DELETE
ON ESPECBEMATIVO FOR EACH ROW
BEGIN
   IF INSERTING THEN
      :NEW.DTULTATU := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF(NVL(:OLD.CDEMPRESA      ,0) <> NVL(:NEW.CDEMPRESA      ,0)) OR
        (NVL(:OLD.CDBEMATIVO     ,0) <> NVL(:NEW.CDBEMATIVO     ,0)) OR
        (NVL(:OLD.CDESPECIFICABEM,0) <> NVL(:NEW.CDESPECIFICABEM,0)) OR
        (NVL(:OLD.DSESPECBEMATIVO,0) <> NVL(:NEW.DSESPECBEMATIVO,0)) OR
        (NVL(:OLD.DTESPECBEMATIVO,TO_DATE('31/12/1899','DD/MM/YYYY')) <> NVL(:NEW.DTESPECBEMATIVO,TO_DATE('31/12/1899','DD/MM/YYYY'))) OR
        (NVL(:OLD.VRESPECBEMATIVO,0) <> NVL(:NEW.VRESPECBEMATIVO,0)) THEN
        :NEW.DTULTATU := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE,CDFILICACHE,DSKEYCACHE,DTULTATUCACH)
      VALUES ('ESPECBEMATIVO','','CDEMPRESA='||:OLD.CDEMPRESA||';CDBEMATIVO='||:OLD.CDBEMATIVO||';CDESPECIFICABEM='||:OLD.CDESPECIFICABEM||';',SYSDATE);
   END IF;
END;
/
ALTER TABLE ESPECBEMATIVO MODIFY DTULTATU DEFAULT SYSDATE
/

UPDATE ESPECBEMATIVO SET DTULTATU = SYSDATE WHERE DTULTATU IS NULL
/
-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_ESPECBEMATIVO','5.05.119'); END;
/

