 /* Tabela EXPAUTFILIAL: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na
tabela EXPAUTFILIAL */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela EXPAUTFILIAL, utilizando
a tabela Geral de Logs de Operaes */
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_ADM_EXPAUTFILIAL' AND
                 TYPE   = 'TR'                   AND
	              U.UID  = O.UID                  AND
	              U.NAME = USER)
DROP TRIGGER LOG_ADM_EXPAUTFILIAL
GO


CREATE TRIGGER LOG_ADM_EXPAUTFILIAL
ON EXPAUTFILIAL
FOR INSERT, UPDATE, DELETE
AS
   DECLARE  @V_USUARIO      VARCHAR(40);
   DECLARE  @V_TIPO         VARCHAR(1);
   DECLARE  @V_ITPESQ       VARCHAR(40);
   DECLARE  @V_DESC         VARCHAR(300);
   DECLARE  @V_CDFILLOGOPER VARCHAR(4);
   DECLARE  @V_DTOPER       DATETIME;
/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE  @V_ID_COMANDO     VARCHAR(1);

   DECLARE  @V_OLD_CDFILIAL    VARCHAR(4);
   DECLARE  @V_OLD_CDRELATEXP  VARCHAR(10);
   DECLARE  @V_OLD_NMARQTXTEXP VARCHAR(30);
   DECLARE  @V_OLD_DSDIRARQEXP VARCHAR(100);
   DECLARE  @V_OLD_NRDIAARQEXP VARCHAR(2);

   DECLARE  @V_NEW_CDFILIAL    VARCHAR(4);
   DECLARE  @V_NEW_CDRELATEXP  VARCHAR(10);
   DECLARE  @V_NEW_NMARQTXTEXP VARCHAR(30);
   DECLARE  @V_NEW_DSDIRARQEXP VARCHAR(100);
   DECLARE  @V_NEW_NRDIAARQEXP VARCHAR(2);
BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';
   SET @V_CDFILLOGOPER = '';

   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
     'D' IDCOMANDO,
         CDFILIAL,
         CDRELATEXP,
         NMARQTXTEXP,
         DSDIRARQEXP,
         NRDIAARQEXP,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL
   FROM
      DELETED
   WHERE
      CDFILIAL+ CDRELATEXP NOT IN (SELECT CDFILIAL+ CDRELATEXP FROM INSERTED)
   UNION ALL

   SELECT
     'U' IDCOMANDO,
         DELETED.CDFILIAL,
         DELETED.CDRELATEXP,
         DELETED.NMARQTXTEXP,
         DELETED.DSDIRARQEXP,
         DELETED.NRDIAARQEXP,
         INSERTED.CDFILIAL,
         INSERTED.CDRELATEXP,
         INSERTED.NMARQTXTEXP,
         INSERTED.DSDIRARQEXP,
         INSERTED.NRDIAARQEXP
   FROM
      INSERTED,
      DELETED
   WHERE
       INSERTED.CDFILIAL   = DELETED.CDFILIAL  AND
       INSERTED.CDRELATEXP = DELETED.CDRELATEXP
   UNION ALL

   SELECT
      'I' IDCOMANDO,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          CDFILIAL,
          CDRELATEXP,
          NMARQTXTEXP,
          DSDIRARQEXP,
          NRDIAARQEXP
   FROM
      INSERTED
   WHERE
      CDFILIAL+ CDRELATEXP NOT IN (SELECT CDFILIAL+ CDRELATEXP FROM DELETED);

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_OLD_CDFILIAL,
                                 @V_OLD_CDRELATEXP,
                                 @V_OLD_NMARQTXTEXP,
                                 @V_OLD_DSDIRARQEXP,
                                 @V_OLD_NRDIAARQEXP,

                                 @V_NEW_CDFILIAL,
                                 @V_NEW_CDRELATEXP,
                                 @V_NEW_NMARQTXTEXP,
                                 @V_NEW_DSDIRARQEXP,
                                 @V_NEW_NRDIAARQEXP;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D' BEGIN
         SET @V_TIPO         = '3';
         SET @V_ITPESQ       = @V_OLD_CDFILIAL + @V_OLD_CDRELATEXP;
         SET @V_CDFILLOGOPER = @V_OLD_CDFILIAL;
         IF @V_OLD_CDFILIAL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Filial=' + @V_OLD_CDFILIAL;
         END;

         IF @V_OLD_CDRELATEXP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' ArqExpor=' + @V_OLD_CDRELATEXP;
         END;

         IF @V_OLD_NMARQTXTEXP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NomeArq=' + @V_OLD_NMARQTXTEXP;
         END;

         IF @V_OLD_DSDIRARQEXP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Diretorio=' + @V_OLD_DSDIRARQEXP;
         END;

         IF @V_OLD_NRDIAARQEXP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DiaGeracao=' + @V_OLD_NRDIAARQEXP;
         END;
      END
      ELSE
         IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN
            IF (@V_OLD_CDFILIAL    <> @V_NEW_CDFILIAL)    OR
               (@V_OLD_CDRELATEXP  <> @V_NEW_CDRELATEXP)  OR
               (@V_OLD_NMARQTXTEXP <> @V_NEW_NMARQTXTEXP) OR
               (@V_OLD_DSDIRARQEXP <> @V_NEW_DSDIRARQEXP) OR
               (@V_OLD_NRDIAARQEXP <> @V_NEW_NRDIAARQEXP) BEGIN

               SET @V_TIPO         = '2';
               SET @V_CDFILLOGOPER = @V_OLD_CDFILIAL;
               SET @V_ITPESQ       = @V_OLD_CDFILIAL + @V_OLD_CDRELATEXP;
            END;
         END
         ELSE BEGIN
            SET @V_TIPO         = '1';
            SET @V_CDFILLOGOPER = @V_NEW_CDFILIAL;
            SET @V_ITPESQ       = @V_NEW_CDFILIAL + @V_NEW_CDRELATEXP;
         END;

      IF @V_NEW_CDFILIAL IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + 'Filial=' + @V_NEW_CDFILIAL;
      END;

      IF @V_NEW_CDRELATEXP IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' ArqExpor=' + @V_NEW_CDRELATEXP;
      END;

      IF @V_NEW_NMARQTXTEXP IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' NomeArq=' + @V_NEW_NMARQTXTEXP;
      END;

      IF @V_NEW_DSDIRARQEXP IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Diretorio=' + @V_NEW_DSDIRARQEXP;
      END;

      IF @V_NEW_NRDIAARQEXP IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' DiaGeracao=' + @V_NEW_NRDIAARQEXP;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_OLD_CDFILIAL,
                                    @V_OLD_CDRELATEXP,
                                    @V_OLD_NMARQTXTEXP,
                                    @V_OLD_DSDIRARQEXP,
                                    @V_OLD_NRDIAARQEXP,

                                    @V_NEW_CDFILIAL,
                                    @V_NEW_CDRELATEXP,
                                    @V_NEW_NMARQTXTEXP,
                                    @V_NEW_DSDIRARQEXP,
                                    @V_NEW_NRDIAARQEXP;


   IF @V_TIPO <> '0' BEGIN
      EXEC NMUSUARIO @V_USUARIO;
      IF NOT @V_DESC IS NULL BEGIN
         IF NOT @V_USUARIO IS NULL BEGIN
            SET @V_DTOPER = GETDATE();
            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO, CDFILLOGOPER)
            VALUES
               ('EXPAUTFILIAL',  @V_DTOPER, @V_USUARIO,
                @V_TIPO,      @V_ITPESQ, @V_DESC, @V_CDFILLOGOPER);
         END;
      END;
   END;

   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_ADM_EXPAUTFILIAL','4.11.105';
GO

